
-- Test jig for Vec-Fonts.E & Vec-Fonts.VF

include get.e
include machine.e

include Vec-Font.E -- Font file

integer junk,Char,Colour,X,Y,TxtLen,Xc,Yc,pix
sequence Text
atom Angle
atom AngInc -- Angle increment
atom FrameTime

junk = graphics_mode(257)
position(24,1)

VFontXscale = 2
VFontYscale = 2
VFontAngleZ = 0
VFontColour = 12

AngInc = 3.14159 / 32
Angle = 0
for y = 0 to 479 do
  pix = floor(25 + (sin(Angle) * 6))
  draw_line(pix,{{0,y},{639,y}})
  Angle = Angle + AngInc
end for

VFontLWidth = 1
Char = 0
for y = 0 to 7 do
  Y = (y * 16)
  for x = 0 to 31 do
    X = (x * 16) + 64
    PlotVChar(X , Y, Char)
    Char = Char + 1
  end for
end for

-- Torus
Text = "Vector Fonts - PeterBlue@CompuServe.Com - "
TxtLen = length(Text)

Xc = 320
Yc = 240
AngInc = 3.14159 / 42
Angle = 0
for r = 160 to 90 by - 1 do
  pix = floor(23 + (sin(Angle) * 7))
  ellipse(pix,1,{Xc - r,Yc - r},{Xc + r,Yc + r})
  Angle = Angle + AngInc
end for

AngInc = (360 / TxtLen)
VFontXscale = 3
VFontYscale = 5
VFontAngleZ = 0
VFontColour = 14
for t = 1 to TxtLen do
  Angle = VFontAngleZ * 0.017453292
  X = Xc + floor(sin(Angle) * 140)
  Y = Yc - floor(cos(Angle) * 140)
  Char = Text[t]
  PlotVChar(X,Y,Char)
  VFontAngleZ = VFontAngleZ + AngInc
end for

VFontCrsrX = 70
VFontCrsrY = 460
VFontXscale = 1
VFontYscale = 2
VFontAngleZ = 0
VFontColour = 4
VFontBackGd = 14 -- Background colour
VFontLWidth = 1
PrintVText(" Press any key when youv'e had enough of this ! ")

-- Falling char demo
VFontAngleZ = 0
VFontXscale = 25
VFontYscale = 25
AngInc = 8
Char = '$'
Colour = 15
tick_rate(100)
while get_key() < 1 do
  FrameTime = time() + 0.08 -- 12.5 Frames per second
  
  VFontColour = 0 -- Black
  PlotVChar(Xc,Yc,Char) -- Erase last char
  
  VFontAngleZ = VFontAngleZ + AngInc -- Calculate next angle
  VFontXscale = VFontXscale - 1 -- Decrease size
  VFontYscale = VFontYscale - 1
  VFontLWidth = floor(VFontXscale / 5)
  VFontColour = Colour -- Get next colour
  PlotVChar(Xc,Yc,Char)
  
  if VFontXscale < 2 then
    VFontXscale = 25
    VFontYscale = 25
    Char = rand(96) + 32
    VFontAngleZ = rand(360)
    Colour = rand(7) + 8
  end if
  
  while time() <= FrameTime do -- Wait for frame to end
  end while
  
end while

junk = graphics_mode(-1)

